-- Old Instance Finder - DrKazza

--Declare Addon and libraries
local OIF = LibStub("AceAddon-3.0"):NewAddon("OldInstanceFinder", "AceConsole-3.0")
local GUI = LibStub("AceGUI-3.0") 
local wholib = LibStub:GetLibrary("LibWho-2.0"):Library()
--local BZ = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local BF = LibStub("LibBabble-Faction-3.0"):GetLookupTable() 
local L = LibStub("AceLocale-3.0"):GetLocale("OldInstanceFinder")
local defaultsearch = "90+" -- Default max level to search for
local maxlevel = 90
LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("OldInstanceFinder", {
	type = "launcher",
	text = "OIF",
	icon = "Interface\\Icons\\Ability_Tracking",
	OnClick = function(clickedframe, button)
	    OIF:BuildMainDisplay() 
	end,
})


local defaults = {
	profile = {
		DungeonList = {
 [1] = { ["name"] = "Ragefire Chasm", ["dosearch"] = false, ["level"] = 16, ["reason"] =L["Achievement"], ["mapid"] = 680},
   [2] = { ["name"] = "Wailing Caverns", ["dosearch"] = false,  ["level"] = 18,  ["reason"] =L["Achievement"],   ["mapid"] = 749 },
   [3] = { ["name"] = "The Deadmines", ["dosearch"] = false,  ["level"] = 20,  ["reason"] =L["Achievement"],   ["mapid"] = 756 },
   [4] = { ["name"] = "Shadowfang Keep", ["dosearch"] = false,  ["level"] = 22,  ["reason"] =L["Achievement"],   ["mapid"] = 764 },
   [5] = { ["name"] = "Blackfathom Deeps", ["dosearch"] = false,  ["level"] = 24,  ["reason"] =L["Achievement"],   ["mapid"] = 688 },
   [6] = { ["name"] = "The Stockade", ["dosearch"] = false,  ["level"] = 25,  ["reason"] =L["Achievement"],   ["mapid"] = 690 },
   [7] = { ["name"] = "Gnomeregan", ["dosearch"] = false,  ["level"] = 30,  ["reason"] =L["Achievement"],   ["mapid"] = 691 },
   [8] = { ["name"] = "Razorfen Kraul", ["dosearch"] = false,  ["level"] = 35,  ["reason"] =L["Achievement"],   ["mapid"] = 761 },
   [9] = { ["name"] = "Scarlet Monastery", ["dosearch"] = false,  ["level"] = 36,  ["reason"] =L["Achievement"],   ["mapid"] = 762 },
   [10] = { ["name"] = "Maraudon", ["dosearch"] = false,  ["level"] = 37,  ["reason"] =L["Achievement"],   ["mapid"] = 750 },
   [11] = { ["name"] = "Uldaman", ["dosearch"] = false,  ["level"] = 40,  ["reason"] =L["Achievement"],   ["mapid"] = 692 },
   [12] = { ["name"] = "Scholomance", ["dosearch"] = false,  ["level"] = 43,  ["reason"] =BF["Argent Dawn"],   ["mapid"] = 763 },
   [13] = { ["name"] = "Zul'Farrak", ["dosearch"] = false,  ["level"] = 44,  ["reason"] =L["Achievement"],   ["mapid"] = 686 },
   [14] = { ["name"] = "Razorfen Downs", ["dosearch"] = false,  ["level"] = 45,  ["reason"] =L["Achievement"],   ["mapid"] = 760 },
   [15] = { ["name"] = "Dire Maul", ["dosearch"] = false,  ["level"] = 45,  ["reason"] =L["Achievement"],   ["mapid"] = 699 },
   [16] = { ["name"] = "Stratholme", ["dosearch"] = false,  ["level"] = 50,  ["reason"] =BF["Argent Dawn"],   ["mapid"] = 765 },
   [17] = { ["name"] = "Blackrock Depths", ["dosearch"] = false,  ["level"] = 54,  ["reason"] =L["Achievement"],   ["mapid"] = 704 },
   [18] = { ["name"] = "The Temple of Atal'Hakkar", ["dosearch"] = false,  ["level"] = 55,  ["reason"] =L["Achievement"],   ["mapid"] = 687 },
   [19] = { ["name"] = "Blackrock Spire", ["dosearch"] = false,  ["level"] = 57,  ["reason"] =L["Achievement"],   ["mapid"] = 721 },
   [20] = { ["name"] = "Molten Core", ["dosearch"] = true,  ["level"] = 60,  ["reason"] =BF["Hydraxian Waterlords"],   ["mapid"] = 696 },
   [21] = { ["name"] = "Blackwing Lair", ["dosearch"] = true,  ["level"] = 60,  ["reason"] =L["Achievement"],   ["mapid"] = 755 },
   [22] = { ["name"] = "Ruins of Ahn'Qiraj", ["dosearch"] = false,  ["level"] = 60,  ["reason"] =BF["Cenarion Circle"].." & "..BF["Brood of Nozdormu"],   ["mapid"] = 717 },
   [23] = { ["name"] = "Temple of Ahn'Qiraj", ["dosearch"] = true,  ["level"] = 60,  ["reason"] =BF["Brood of Nozdormu"],   ["mapid"] = 766 },
   [24] = { ["name"] = "Hellfire Ramparts", ["dosearch"] = true,  ["level"] = 61,  ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"],   ["mapid"] = 797 },
   [25] = { ["name"] = "The Blood Furnace", ["dosearch"] = true,  ["level"] = 62,  ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"],   ["mapid"] = 725 },
   [26] = { ["name"] = "The Slave Pens", ["dosearch"] = false,  ["level"] = 62,  ["reason"] =BF["Cenarion Expedition"],   ["mapid"] = 728 },
   [27] = { ["name"] = "The Underbog", ["dosearch"] = false,  ["level"] = 64,  ["reason"] =BF["Cenarion Expedition"],   ["mapid"] = 726 },
   [28] = { ["name"] = "Mana-Tombs", ["dosearch"] = false,  ["level"] = 65,  ["reason"] =BF["The Consortium"],   ["mapid"] = 732 },
   [29] = { ["name"] = "Auchenai Crypts", ["dosearch"] = true,  ["level"] = 66,  ["reason"] =BF["Lower City"],   ["mapid"] = 722 },
   [30] = { ["name"] = "Old Hillsbrad Foothills", ["dosearch"] = true,  ["level"] = 67,  ["reason"] =BF["Keepers of Time"],   ["mapid"] = 734 },
   [31] = { ["name"] = "Sethekk Halls", ["dosearch"] = true,  ["level"] = 68,  ["reason"] =BF["Lower City"],   ["mapid"] = 723 },
   [32] = { ["name"] = "The Steamvault", ["dosearch"] = false,  ["level"] = 69,  ["reason"] =BF["Cenarion Expedition"],   ["mapid"] = 727 },
   [33] = { ["name"] = "Shadow Labyrinth", ["dosearch"] = true,  ["level"] = 69,  ["reason"] =BF["Lower City"],   ["mapid"] = 724 },
   [34] = { ["name"] = "The Shattered Halls", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["Thrallmar"].."/"..BF["Honor Hold"],   ["mapid"] = 710 },
   [35] = { ["name"] = "The Black Morass", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["Keepers of Time"],   ["mapid"] = 733 },
   [36] = { ["name"] = "The Botanica", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["The Sha'tar"],   ["mapid"] = 729 },
   [37] = { ["name"] = "The Mechanar", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["The Sha'tar"],   ["mapid"] = 730 },
   [38] = { ["name"] = "The Arcatraz", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["The Sha'tar"],   ["mapid"] = 731 },
   [39] = { ["name"] = "Magisters' Terrace", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 798 },
   [40] = { ["name"] = "Karazhan", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["The Violet Eye"],   ["mapid"] = 799 },
   [41] = { ["name"] = "Gruul's Lair", ["dosearch"] = false,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 776 },
   [42] = { ["name"] = "Magtheridon's Lair", ["dosearch"] = false,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 779 },
   [43] = { ["name"] = "Serpentshrine Cavern", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 780 },
   [44] = { ["name"] = "Tempest Keep", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 782 },
   [45] = { ["name"] = "Hyjal Summit", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["The Scale of the Sands"],   ["mapid"] = 775 },
   [46] = { ["name"] = "Black Temple", ["dosearch"] = true,  ["level"] = 70,  ["reason"] =BF["Ashtongue Deathsworn"],   ["mapid"] = 796 },
   [47] = { ["name"] = "Sunwell Plateau", ["dosearch"] = false,  ["level"] = 70,  ["reason"] =L["Achievement"],   ["mapid"] = 789 },
   [48] = { ["name"] = "Utgarde Keep", ["dosearch"] = false,  ["level"] = 71,  ["reason"] =L["Achievement"],   ["mapid"] = 523 },
   [49] = { ["name"] = "The Nexus", ["dosearch"] = false,  ["level"] = 72,  ["reason"] =L["Achievement"],   ["mapid"] = 520 },
   [50] = { ["name"] = "Azjol-Nerub", ["dosearch"] = false,  ["level"] = 73,  ["reason"] =L["Achievement"],   ["mapid"] = 533 },
   [51] = { ["name"] = "Ahn'kahet: The Old Kingdom", ["dosearch"] = false,  ["level"] = 74,  ["reason"] =L["Achievement"],   ["mapid"] = 522 },
   [52] = { ["name"] = "Drak'Tharon Keep", ["dosearch"] = false,  ["level"] = 75,  ["reason"] =L["Achievement"],   ["mapid"] = 534 },
   [53] = { ["name"] = "The Violet Hold", ["dosearch"] = false,  ["level"] = 76,  ["reason"] =L["Achievement"],   ["mapid"] = 536 },
   [54] = { ["name"] = "Gundrak", ["dosearch"] = false,  ["level"] = 77,  ["reason"] =L["Achievement"],   ["mapid"] = 530 },
   [55] = { ["name"] = "Halls of Stone", ["dosearch"] = false,  ["level"] = 78,  ["reason"] =L["Achievement"],   ["mapid"] = 526 },
   [56] = { ["name"] = "Halls of Lightning", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 525 },
   [57] = { ["name"] = "The Oculus", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 528 },
   [58] = { ["name"] = "The Culling of Stratholme", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 521 },
   [59] = { ["name"] = "Utgarde Pinnacle", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 524 },
   [60] = { ["name"] = "Trial of the Champion", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 542 },
   [61] = { ["name"] = "The Forge of Souls", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 601 },
   [62] = { ["name"] = "Pit of Saron", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 602 },
   [63] = { ["name"] = "Halls of Reflection", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 603 },
   [64] = { ["name"] = "Naxxramas", ["dosearch"] = true,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 535 },
   [65] = { ["name"] = "The Obsidian Sanctum", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 531 },
   [66] = { ["name"] = "The Eye of Eternity", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 527 },
   [67] = { ["name"] = "Onyxia's Lair", ["dosearch"] = true,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 718 },
   [68] = { ["name"] = "Ulduar", ["dosearch"] = true,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 529 },
   [69] = { ["name"] = "Trial of the Crusader", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 543 },
   [70] = { ["name"] = "Vault of Archavon", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 532 },
   [71] = { ["name"] = "Icecrown Citadel", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =BF["The Ashen Verdict"],   ["mapid"] = 604 },
   [72] = { ["name"] = "The Ruby Sanctum", ["dosearch"] = false,  ["level"] = 80,  ["reason"] =L["Achievement"],   ["mapid"] = 609 },
   [73] = { ["name"] = "Throne of the Tides", ["dosearch"] = false,  ["level"] = 81,  ["reason"] =L["Achievement"],   ["mapid"] = 767 },
   [74] = { ["name"] = "Blackrock Caverns", ["dosearch"] = false,  ["level"] = 81,  ["reason"] =L["Achievement"],   ["mapid"] = 753 },
   [75] = { ["name"] = "The Vortex Pinnacle", ["dosearch"] = false,  ["level"] = 82,  ["reason"] =L["Achievement"],   ["mapid"] = 769 },
   [76] = { ["name"] = "The Stonecore", ["dosearch"] = false,  ["level"] = 83,  ["reason"] =L["Achievement"],   ["mapid"] = 768 },
   [77] = { ["name"] = "Lost City of the Tol'vir", ["dosearch"] = false,  ["level"] = 84,  ["reason"] =L["Achievement"],   ["mapid"] = 747 },
   [78] = { ["name"] = "Halls of Origination", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 759 },
   [79] = { ["name"] = "Grim Batol", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 757 },
   [80] = { ["name"] = "Baradin Hold", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 752 },
   [81] = { ["name"] = "The Bastion of Twilight", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 758 },
   [82] = { ["name"] = "Throne of the Four Winds", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 773 },
   [83] = { ["name"] = "Blackwing Descent", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 754 },
   [84] = { ["name"] = "Zul'Gurub", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 793 },
   [85] = { ["name"] = "Zul'Aman", ["dosearch"] = true,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 781 },
   [86] = { ["name"] = "Hour of Twilight", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 819 },
   [87] = { ["name"] = "Well of Eternity", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 816 },
   [88] = { ["name"] = "End Time", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 820 },
   [89] = { ["name"] = "Firelands", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =BF["Avengers of Hyjal"],   ["mapid"] = 800 },
   [90] = { ["name"] = "Dragon Soul", ["dosearch"] = false,  ["level"] = 85,  ["reason"] =L["Achievement"],   ["mapid"] = 824 },
   [91] = { ["name"] = "Temple of the Jade Serpent", ["dosearch"] = false,  ["level"] = 86,  ["reason"] =L["Achievement"],   ["mapid"] = 867 },
   [92] = { ["name"] = "Stormstout Brewery", ["dosearch"] = false,  ["level"] = 86,  ["reason"] =L["Achievement"],   ["mapid"] = 876 },
   [93] = { ["name"] = "Shado-pan Monastery", ["dosearch"] = false,  ["level"] = 88,  ["reason"] =L["Achievement"],   ["mapid"] = 877 },
   [94] = { ["name"] = "Mogu'Shan Palace", ["dosearch"] = false,  ["level"] = 88,  ["reason"] =L["Achievement"],   ["mapid"] = 885 },
   [95] = { ["name"] = "Siege of Niuzao Temple", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 887 },
   [96] = { ["name"] = "Gate of the Setting Sun", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 875 },
   [97] = { ["name"] = "Mogu'shan Vaults", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 896 },
   [98] = { ["name"] = "Terrace of Endless Spring", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 886 },
   [99] = { ["name"] = "Heart of Fear", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 897 },
   [100] = { ["name"] = "Throne of Thunder", ["dosearch"] = false,  ["level"] = 90,  ["reason"] =L["Achievement"],   ["mapid"] = 930 },
		}
	      }
	}

-- -------------------------------------------------------
-- Create the main window and the spacing
-- -------------------------------------------------------
local oifdisplay
local cbwidth = 30
local namewidth = 225
local lvlwidth = 75
local reasonwidth = 225 
local db
local textentered

-- -------------------------------------------------------
function OIF:OnInitialize() 
-- -------------------------------------------------------
    OIF:RegisterChatCommand("OIF", "Slash")
    OIF:RegisterChatCommand("OldInstanceFinder", "Slash")
    OIF.db = LibStub("AceDB-3.0"):New("OIFDB", defaults)
    db = OIF.db.profile
end

-- -------------------------------------------------------
function OIF:Enable() 
-- -------------------------------------------------------
   oifdisplay:Hide()
	
end 


-- -------------------------------------------------------
function OIF:Slash(msg)
-- -------------------------------------------------------
  if msg == "" or nil then 
    OIF:BuildMainDisplay() 
  else
    OIF:cmdlinesearch(msg)
  end
end

-- -------------------------------------------------------
function OIF:cmdlinesearch(msg)
-- -------------------------------------------------------
        if tonumber(msg) then
		-- Arguement is a number, searching for a specific level
            OIF:StartSearch(msg)
            return;
	  else 
		local lookforplus = string.find(msg, "%+")
		if lookforplus then
			-- Arguement has a + so look for the digits preceeding it and search to max level
			_, _, minlevel = string.find(msg, "(%d+)%+")
			if tonumber(minlevel) then
		            OIF:StartSearch(minlevel, maxlevel)
            		    return;
			else
				-- The digits preceeding the + were not a number - return usage message
			      OIF:Usage()
			end
		end

		local lookforminus = string.find(msg, "%-")
		local lowerlvl
		local upperlvl
		if lookforminus then
			-- Arguement has a - so look for the digits preceeding and following it
			_, _, lowerlvl, upperlvl = string.find(msg, "(%d+)%-(%d+)")
			if tonumber(lowerlvl) and tonumber(upperlvl) then
		            OIF:StartSearch(lowerlvl, upperlvl)				
            		    return;
			else
				-- The digits preceeding and following the - were not numbers - return usage message
			      OIF:Usage()
			end
		end
        end
end

-- -------------------------------------------------------
function OIF:Usage()
-- -------------------------------------------------------
    OIF:Print(L["Usage"])
end


local isranged
-- -------------------------------------------------------
function OIF:StartSearch(a, ...)
-- -------------------------------------------------------

if ... then
	isranged = true
	lvlstring = a.."-".. ...
else
	-- only one arguement passed therefore search for one level only
	isranged = false
	lvlstring = a
end

local searchessent = 0

    for i=1, #db.DungeonList do
        if db.DungeonList[i]["dosearch"] then
           local tempname = GetMapNameByID(db.DungeonList[i]["mapid"])
           searchquery = 'z-'..tempname..' '..lvlstring

           local searchresult = wholib:Who(
           searchquery,
           {
           queue = wholib.WHOLIB_QUEUE_SCANNING,
           --flags = whoLib.WHOLIB_FLAG_ALWAYS_CALLBACK,   -- not sure what this does but it works without it!
           callback = self.CatchWhoResults
           });
           if(searchresult) then
                self.CatchWhoResults(searchresult);
           end
        searchessent = searchessent + 1
	end
    end
    OIF:Print((L["Startsearch"]):format(searchessent))
end

-- -------------------------------------------------------
function OIF:CatchWhoResults(results, complete)
-- -------------------------------------------------------
    if results == nil or #results == 0 then
        -- no one in this dungeon
    else
        currentzone = results[1].Zone;
        level = results[1].Level;
        numofrunners = #results;

		if complete then
			if numofrunners == 1 then
				OIF:Print((L["OneHit"]) :format(level, currentzone));
			else
				if isranged then
					OIF:Print((L["MoreHitsRange"]) :format(numofrunners, currentzone))
				else
					OIF:Print((L["MoreHits"]) :format(numofrunners, level, currentzone))
				end
			end
		else
			if isranged then
				OIF:Print((L["LotsHitsRange"]) :format(currentzone))
			else
				OIF:Print((L["LotsHits"]) :format(level, currentzone))
			end
		end
    end
end



-- -------------------------------------------------------
function OIF:RefreshDisplay() 
-- -------------------------------------------------------
    OIF:BuildMainDisplay() 
end 


-- -------------------------------------------------------
function OIF:BuildMainDisplay() 
-- -------------------------------------------------------
   if oifdisplay and oifdisplay:IsVisible() then 
      oifdisplay:Hide() 
      return 
   end 


   oifdisplay = GUI:Create("Frame");
--set global name
   _G["OIF_display"] = oifdisplay
--use escape to close
   tinsert(UISpecialFrames, "OIF_display")

   local dscroll = GUI:Create("ScrollFrame");

   oifdisplay:SetTitle(L["Old Instance Finder"]) 
   oifdisplay:SetLayout("Flow") 
   oifdisplay:SetStatusTable{width=800} 

-- This bit stops the window being resized but the functionality was removed from AceGUI-3.0
--   oifdisplay.sizer_se:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_se:SetScript("OnMouseUp",nil) 
--   oifdisplay.sizer_s:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_s:SetScript("OnMouseUp",nil) 
--   oifdisplay.sizer_e:SetScript("OnMouseDown",nil) 
--   oifdisplay.sizer_e:SetScript("OnMouseUp",nil) 

   oifdisplay:SetCallback("OnClose", function(_oifdisplay) 
      GUI:Release(_oifdisplay) 
   end) 


   local titlesg = GUI:Create("SimpleGroup") 
   titlesg:SetLayout("Flow")
   titlesg:SetHeight(100)
   titlesg:SetFullWidth(true)

   local titlegap = GUI:Create("Label")
   titlegap:SetWidth(cbwidth)
   titlegap:SetText(" ")

   local titledung = GUI:Create("Label")
   titledung:SetWidth(namewidth)
   titledung:SetText(L["Dungeon/Instance/Raid:"])

   local titlelvl = GUI:Create("Label")
   titlelvl:SetWidth(lvlwidth)
   titlelvl:SetText(L["Level:"])

   local titlereason = GUI:Create("Label")
   titlereason:SetWidth(reasonwidth)
   titlereason:SetText(L["Faction/Purpose:"])

   titlesg:AddChildren(titlegap, titledung, titlelvl, titlereason)

 
   oifdisplay:AddChild(titlesg) 

-- this bit creates a space below the title area, layout aesthetics
   local minispacer = GUI:Create("SimpleGroup")
   minispacer:SetLayout("Flow")
   minispacer:SetHeight(100)
   minispacer:SetFullWidth(true)
   local minigap = GUI:Create("Label")
   minigap:SetFullWidth(true)
   minigap:SetText(" ")
   minispacer:AddChild(minigap)
   oifdisplay:AddChild(minispacer) 



-- Create a pair of Inline groups to sit inside it
   local rhswidth = 0.2

   local lhs_sg = GUI:Create("SimpleGroup") 
   lhs_sg:SetLayout("Fill")
   lhs_sg:SetRelativeWidth(0.99-rhswidth) 
   lhs_sg:SetFullHeight(true)

   local rhs_sg = GUI:Create("SimpleGroup");
   rhs_sg:SetLayout("Flow");
   rhs_sg:SetRelativeWidth(rhswidth);
   rhs_sg.alignoffset = 25

-- Add the Easy Stuff to the Right Hand Side
local h1, h2, sp1, sp2, edbox, bsearch, bload, bsave, bclear, htext

-- Header above search button 
   h1 = GUI:Create("Heading") 
   h1:SetFullWidth(true) 
   h1:SetText(L["Run Search"]) 
   rhs_sg:AddChild(h1) 
 
-- Edit box for level search 
   local edbox = GUI:Create("EditBox") 
   edbox:SetRelativeWidth(1) 
   if textentered then 
      edbox:SetText(textentered) 
   else
      edbox:SetText(defaultsearch) 
   end
   edbox:SetCallback("OnEnterPressed", function(_b, _event, text) 
--      OIF:Print("Text Entry... "..text.." run the search now")
	textentered = text
   end) 
   rhs_sg:AddChild(edbox) 
 
-- Search button 
   bsearch = GUI:Create("Button") 
   bsearch:SetText(L["Search"]) 
   bsearch:SetRelativeWidth(1) 
   bsearch:SetCallback("OnClick", function() 
	if textentered then
	      OIF:cmdlinesearch(textentered)
	else
	      OIF:cmdlinesearch(defaultsearch) 
	end
      oifdisplay:Hide() 
   end) 
   rhs_sg:AddChild(bsearch) 

-- help text
   local htext = GUI:Create("Label")
   htext:SetRelativeWidth(1)
   htext:SetText(L["Help Text"])
   rhs_sg:AddChild(htext)


--  Leave a gap
   sp1 = GUI:Create("Spacer")
   sp1:SetFullWidth(true)
   sp1:SetHeight(50)
   rhs_sg:AddChild(sp1)
 
--  Saving Preferences and Clearing selections 
   h2 = GUI:Create("Heading") 
   h2:SetFullWidth(true) 
   h2:SetText(L["Preferences"]) 
   rhs_sg:AddChild(h2) 
 
--[[
--  Save Button 
   bsave = GUI:Create("Button") 
   bsave:SetText(L["Save Selection"]) 
   bsave:SetRelativeWidth(1) 
   bsave:SetCallback("OnClick", function() 
       OIF.db.profile.DungeonList = db.DungeonList
--       OIF:Print("Save To SV") 
   end) 
   rhs_sg:AddChild(bsave) 
]]
 
--  Load Button 
   bload = GUI:Create("Button") 
   bload:SetText(L["Load Defaults"]) 
   bload:SetRelativeWidth(1) 
   bload:SetCallback("OnClick", function() 
       db.DungeonList = defaults.profile.DungeonList
	 oifdisplay:Hide()
--       OIF:Print("Load From SV")
	OIF:RefreshDisplay()
	return 
	 -- yeah annoying isn't it... 
       -- however I don't know how to refresh the checkbox selections so I've got to rebuild the whole bloody thing!
   end) 
   rhs_sg:AddChild(bload) 

-- Leave a gap
   sp2 = GUI:Create("Spacer")
   sp2:SetFullWidth(true)
   sp2:SetHeight(50)
   rhs_sg:AddChild(sp2)
 
--  Clear All Button 
   bclear = GUI:Create("Button") 
   bclear:SetText(L["Clear All"]) 
   bclear:SetFullWidth(true) 
   bclear:SetCallback("OnClick", function() 

	for i=1, #db.DungeonList do
        db.DungeonList[i]["dosearch"] = false
	end
	
--	OIF:Print("Clearing all Dungeons") 
	oifdisplay:Hide()
	OIF:RefreshDisplay()
	return 
      -- see load button for pitiful excuses
   end) 
   rhs_sg:AddChild(bclear) 
--  don't care about putting a warning, if people clear and save then it'll only take a few seconds to repopulate. 




--  Left Hand Panel Scrolling Dungeon Selector 
   local sf = GUI:Create("ScrollFrame"); 
   sf:SetLayout("List")

 
--  Start adding the list of dungeons, each with its own checkbox 
   local searchbool, dungeonname, levelstr, reason
	for i=1, #db.DungeonList do

-- add a block for the contents.
      local entryline = GUI:Create("SimpleGroup")
      entryline:SetRelativeWidth(0.99)
	entryline:SetHeight(15)
	entryline:SetLayout("Flow")

       local cb = GUI:Create("CheckBox")
	cb:SetType("checkbox")
        cb:SetWidth(cbwidth)
	searchbool = db.DungeonList[i]["dosearch"]
	cb:SetValue(searchbool)
         OIF:CheckBoxDefinition(cb, i)
         -- yes I did it... don't even go there!
	entryline:AddChild(cb)

-- Dungeon Name
      local dungname = GUI:Create("Label")
	dungname:SetWidth(namewidth)
	dungeonname = GetMapNameByID(db.DungeonList[i]["mapid"])
	dungname:SetText(dungeonname)
	entryline:AddChild(dungname)

-- Level recommendation
      local lvlrec = GUI:Create("Label")
	lvlrec:SetWidth(lvlwidth)
	levelstr = db.DungeonList[i]["level"]
	lvlrec:SetText(levelstr)
	entryline:AddChild(lvlrec)

-- Reason
      local dreason = GUI:Create("Label")
	dreason:SetWidth(reasonwidth)
	reason = db.DungeonList[i]["reason"]
	dreason:SetText(reason)
	entryline:AddChild(dreason)



	sf:AddChild(entryline)
   end 

   lhs_sg:AddChild(sf) 
   oifdisplay:AddChild(lhs_sg)
   oifdisplay:AddChild(rhs_sg) 
   sf:ResumeLayout() 
   oifdisplay:ResumeLayout() 
   oifdisplay:ApplyStatus() 
   return oifdisplay 
end 


-- -------------------------------------------------------
-- Checkbox function allocation
-- -------------------------------------------------------
function OIF:CheckBoxDefinition(chkbx, n)
   chkbx:SetCallback("OnValueChanged", function(cb, event, value)
      db.DungeonList[n]["dosearch"] = value
      end)

end

